float scale = 0.00015, scale2 = 0.025, offs = 0;

//////////////////////////////////////////////////////
class lnoise
{
  float[] ns;
  lnoise() { ns = new float[100]; for (int i = 0; i < 100; i++) ns[i] = random(1.0); };
  float get(float t)
  { 
    t = t - floor(t);
    int i1 = floor(t * 100) % 100, i2 = (i1 + 1) % 100;
    return ns[i1] + (ns[i2] - ns[i1]) * (t - i1 * 0.01) * 100;
  }; 
};

lnoise ns;

//////////////////////////////////////////////////////
void setup()
{ 
  size(800, 450); smooth(); frameRate (20); noStroke(); background(0,0,0); fill (255, 125, 0);
  noiseDetail(5, 0.5);
  ns = new lnoise();
}

void draw()
{   
  
  background(70, 0, 0);
  fill (124, 25, 0); ellipse (width * 0.75, height * 0.55, 200, 200);
  fill (255, 115, 0); ellipse (width * 0.25, height * 0.075, 125, 125);
  offs += 0.00025;
  landscape (0.45, 0.25, offs * 0.125 + 0.37, color(100, 5, 0)); 
  landscape (0.4, 0.5, offs * 0.25 + 0.2, color(150, 25, 0)); 
  landscape (0.3, 0.75, offs * 0.5 + 0.1, color(200, 50, 0)); 
  landscape (0.1, 1.5, offs, color(255, 100, 0)); 
};

//////////////////////////////////////////////////////
float lower (float t, float l) { l = 1 - t * l; if (l == 0) return 1; else return 1 - (1 - t) / l; };

void landscape (float lev, float sc, float ofs, color c)
{
  fill (c);
  beginShape();
  vertex (0, height);
  for (int x = 0; x <= width; x += 1)
  { float n = lev + 5 * sc * min(lower(ns.get(x * (scale / sc) + ofs) * ns.get(x * 0.75 * (scale / sc) + ofs + 0.247), 0.970), 0.1) + 0.075 * sc * noise(x * (scale2 / sc) + ofs);
    vertex (x, height - n * height);
  };
  vertex (width - 1, height);
  endShape(CLOSE);
};
